function rimwheel_settings_onload()
{
	var prefs = Components.classes["@mozilla.org/preferences-service;1"]
		.getService(Components.interfaces.nsIPrefService)
		.getBranch("extensions.rimwheel.");

	var v;
	document.getElementById("rimwheel_settings_enabled").checked
		= rimwheel_getBoolPref(prefs, "enabled", true);
	document.getElementById("rimwheel_settings_rimsize").value
		= rimwheel_getIntPref(prefs, "rimsize", 64);
	document.getElementById("rimwheel_settings_pageratio").value
		= rimwheel_getCharPref(prefs, "pageratio", 0.9);
	document.getElementById("rimwheel_settings_scrollsize").value
		= rimwheel_getIntPref(prefs, "scrollsize", 48);
	document.getElementById("rimwheel_settings_debug").checked
		= rimwheel_getBoolPref(prefs, "debug", false);
}

function rimwheel_getBoolPref(prefs, name, d)
{
	if (prefs.prefHasUserValue(name))
		return prefs.getBoolPref(name);
	else
		return d;
}

function rimwheel_getIntPref(prefs, name, d)
{
	if (prefs.prefHasUserValue(name))
		return prefs.getIntPref(name);
	else
		return d;
}

function rimwheel_getCharPref(prefs, name, d)
{
	if (prefs.prefHasUserValue(name))
		return prefs.getCharPref(name);
	else
		return d;
}

function rimwheel_settings_ondialogaccept()
{
	if (document.getElementById("rimwheel_settings_clear").checked) {
		rimwheel_settings_clear();
	} else {
		rimwheel_settings_update();
	}
}

function rimwheel_settings_update()
{
	var prefs = Components.classes["@mozilla.org/preferences-service;1"]
		.getService(Components.interfaces.nsIPrefService)
		.getBranch("extensions.rimwheel.");

	prefs.setBoolPref("enabled",
		document.getElementById("rimwheel_settings_enabled").checked);
	prefs.setBoolPref("debug",
		document.getElementById("rimwheel_settings_debug").checked);
	prefs.setIntPref("rimsize",
		document.getElementById("rimwheel_settings_rimsize").value);
	prefs.setCharPref("pageratio",
		document.getElementById("rimwheel_settings_pageratio").value);
	prefs.setIntPref("scrollsize",
		document.getElementById("rimwheel_settings_scrollsize").value);
}

function rimwheel_settings_clear()
{
	var prefs = Components.classes["@mozilla.org/preferences-service;1"]
		.getService(Components.interfaces.nsIPrefService)
		.getBranch("extensions.rimwheel.");

	try {
		prefs.clearUserPref("enabled");
	} catch (e) { }
	try {
		prefs.clearUserPref("debug");
	} catch (e) { }
	try {
		prefs.clearUserPref("rimsize");
	} catch (e) { }
	try {
		prefs.clearUserPref("pageratio");
	} catch (e) { }
	try {
		prefs.clearUserPref("scrollsize");
	} catch (e) { }
}
